<SCRIPT LANGUAGE="JavaScript" SRC="/roster/addons/raidtracker/js/calendar.js"></SCRIPT>
	<SCRIPT LANGUAGE="JavaScript">
		var cal = new CalendarPopup();
	</SCRIPT>
<?php

if (!defined('ROSTER_INSTALLED') ) {
        exit('Detected invalid access to this file!');
}

$roster_login = new RosterLogin();

if( !$roster_login->getAuthorized($addon['config']['raidtracker_viewaccess']))
{
        print $roster_login->getMessage().
        $roster_login->getLoginForm($addon['config']['raidtracker_viewaccess']);
        return; //To the addon framework
}

require_once( $addon['dir'] . 'inc/raidtracker.class.php' );

$tracker = new RaidTracker();
$itracker = new RaidTrackerItem();

//echo "Realm loot screen";
//$tracker->GetLoot("realm");

if( !active_addon('memberslist') )
{
    // Memberslist not installed. Just die for now.
    roster_die( "You will need to install memberslist to use the keys addon display component" );
}

$memberslist_addon = getaddon('memberslist');

// Include addon's locale files if they exist
foreach( $roster->multilanguages as $lang )
{
    $roster->locale->add_locale_file($memberslist_addon['locale_dir'] . $lang . '.php',$lang);
}

// Check whether we have a quality minimum set
$quality = isset($_POST['quality']) ? htmlspecialchars($_POST['quality']) : 4;
$qualitystr = $tracker->GetColorSQL($quality);

//$defaultoffset = 31536000; // 1 year
$defaultoffset = $addon['config']['raidtracker_querydefault'];

$startdate = isset($_POST['startdate']) ? htmlspecialchars($_POST['startdate'])." 00:00:01" : date("Y-m-d",time()-$defaultoffset)." 00:00:01";
$enddate = isset($_POST['enddate']) ? htmlspecialchars($_POST['enddate'])." 23:59:59" : date("Y-m-d",time())." 23:59:59";

// If we get an item reference, we are looking for specific loot drops
$itemref = isset($_GET['itemref']) ? htmlspecialchars($_GET['itemref']) : NULL;

if($itemref != NULL) {
	$id = array_shift( explode( ":", $itemref ) );
	include_once ($memberslist_addon['dir'] . 'inc/memberslist.php');
	include_once (ROSTER_LIB . 'item.php');

	$memberlist = new memberslist(array('group_alts'=>-1));
	//SELECT l.*,r.raidID,p.guild_name FROM `roster20_addons_raidtracker_items` l LEFT JOIN `roster20_addons_raidtracker_raids` r ON r.raidID = l.raidFK JOIN `roster20_addons_raidtracker_raidmembers` p ON p.name = l.member WHERE r.realm = 'Azjol-Nerub' AND l.deleted = '0' GROUP BY l.itemname ASC ORDER BY r.raidtime ASC,l.itemname ASC

	// First define static data
	$mainSelect =
	    'SELECT '.
	    '`l`.`lootID`, '.
	    '`l`.`itemname`, '.
			'`l`.`itemref`, '.
	    '`l`.`icon`, '.
	    '`l`.`boss`, '.
	    '`l`.`color`, '.
	    '`l`.`loottime`, '.
	    '`l`.`member`, '.
	    '`l`.`note`, '.
	    '`r`.`zone`, '.
			'`r`.`raidID`, '.
			'`p`.`guild_name`, '.
			'`c`.`member_id`, '.
			'`g`.`guild_id`, ';
	
	$mainTables =
	    'FROM `'.$roster->db->table('items','raidtracker').'` AS l '.
			'LEFT JOIN `'.$roster->db->table('raids','raidtracker').'` AS r ON `r`.`raidID` = `l`.`raidFK`'.
			'LEFT JOIN `'.$roster->db->table('raidmembers','raidtracker').'` AS p ON `p`.`name` = `l`.`member` '.
			'LEFT JOIN `'.$roster->db->table('guild').'` AS g ON `p`.`guild_name` = `g`.`guild_name` '.
			'LEFT JOIN `'.$roster->db->table('players').'` AS c ON `c`.`name` = `l`.`member` '.
			'WHERE r.realm = "'.$roster->data['server'].'" AND l.deleted = 0 '.
			$qualitystr .
			' AND l.loottime > "'.$startdate.'" AND l.loottime < "'.$enddate.'" AND l.itemref like "'.$id.':%" '.
//	    'GROUP BY `l`.`loottime` '.
	    'ORDER BY ';
	
	$always_sort = ' `l`.`loottime` DESC, `l`.`member` ASC' ;
	
	/*
	$FIELD['lootID'] = array (
	    'lang_field' => 'lootID',
	    'order'    => array( '`l`.`lootID` ASC' ),
	    'order_d'    => array( '`l`.`lootID` DESC' ),
	//	'value' => array($memberlist,'icon_value'),
	    'js_type' => 'ts_number',
	    'display' => 3,
	);
	*/

	$FIELD['zone'] = array (
		'lang_field' => $roster->locale->act['zone'],
		'order' => array( '`r`.`zone` ASC' ),
		'order_d' => array( '`r`.`zone` DESC' ),
		'value' => 'zone_value',
		'js_type' => 'ts_string',
		'display' => 2,
	);

	$FIELD['member'] = array (
	    'lang_field' => $roster->locale->act['h_who_received'],
	    'order'    => array( '`l`.`member` ASC' ),
	    'order_d'    => array( '`l`.`member` DESC' ),
	//	'value' => array($memberlist,'member_value'),
	    'js_type' => 'ts_string',
	    'display' => 3,
	);

	$FIELD['itemname'] = array (
	    'lang_field' => 'itemname',
	    'order'    => array( '`l`.`itemname` ASC' ),
	    'order_d'    => array( '`l`.`itemname` DESC' ),
	//	'value' => array($memberlist,'itemname_value'),
	    'js_type' => 'ts_string',
	    'display' => 2,
	);
		
	$FIELD['guild_name'] = array (
		'lang_field' => $roster->locale->act['guild'],
		'order'		=> array( '`p`.`guild_name` ASC' ),
		'order_d'	=> array( '`p`.`guild_name` DESC' ),
		'value' 	=> 'guild_value',
		'js_type'	=> 'ts_string',
		'display'	=> 3,
	);
	
	$FIELD['loottime'] = array (
		'lang_field' => $roster->locale->act['h_date_received'],
		'order' => array( '`l`.`loottime` ASC' ),
		'order_d' => array( '`l`.`loottime` DESC' ),
	//	'value' => 'loottime_value',
		'js_type' => 'ts_string',
		'display' => 2,
	);
	
	$FIELD['boss'] = array (
		'lang_field' => $roster->locale->act['tooltip_boss'],
		'order' => array( '`l`.`boss` ASC' ),
		'order_d' => array( '`l`.`boss` DESC' ),
		'js_type' => 'ts_string',
		'display' => 2,
	);

	// Combine the main query. The '1' is to fix the trailing comma for the fields list.
	$mainQuery = $mainSelect . '1 ' . $mainTables;
	
	$memberlist->prepareData($mainQuery, $always_sort, $FIELD, 'lootlist');
	
	echo $memberlist->makeFilterBox();

	echo $memberlist->makeToolBar('horizontal');

	// Display the results
	echo "<br />\n".border('sgreen','start',$roster->locale->act['h_who_received'].':',"30%");
	echo "<font size='+1'>".$itracker->fetchItemNameHTML($itemref)."</font><hr />";
	echo "<div align='center'>".$itracker->fetchItemOrArmory($id)."</div>";
//	echo $mainQuery;
	echo border('sgreen','end');
	
	echo "<br />\n".border('syellow','start')."\n";
	echo $memberlist->makeMembersList();
	echo border('syellow','end');

	aprint($mainQuery.$always_sort);

} else {
	// Otherwise we'll handle the entire loot list.
	// $data = $tracker->GetLoot("char", $quality);
	$memberslist_addon = getaddon('memberslist');
	
	// Include addon's locale files if they exist
	foreach( $roster->multilanguages as $lang ) {
		$roster->locale->add_locale_file($memberslist_addon['locale_dir'] . $lang . '.php',$lang);
	}
	
	// Date debug
	// echo "Received start date: ".$startdate."<br>";
	// echo "Received end date: ".$enddate."<br>";
	
	include_once ($memberslist_addon['dir'] . 'inc/memberslist.php');
	include_once (ROSTER_LIB . 'item.php');
	//$memberlist = new memberslist(array(), $memberslist_addon);
	$memberlist = new memberslist(array('group_alts'=>-1));
	//SELECT l.*,r.raidID,p.guild_name FROM `roster20_addons_raidtracker_items` l LEFT JOIN `roster20_addons_raidtracker_raids` r ON r.raidID = l.raidFK JOIN `roster20_addons_raidtracker_raidmembers` p ON p.name = l.member WHERE p.guild_name = 'Vestra Mater' AND r.realm = 'Azjol-Nerub' AND r.faction = 'Alliance' AND l.deleted = '0' GROUP BY l.itemname ASC ORDER BY r.raidtime ASC,l.itemname ASC

	// First define static data
	$mainSelect =
	    'SELECT '.
	    '`l`.`lootID`, '.
	    '`l`.`itemname`, '.
			'`l`.`itemref`, '.
	    '`l`.`icon`, '.
	    '`l`.`boss`, '.
	    '`l`.`color`, '.
	    '`l`.`loottime`, '.
	    '`l`.`member`, '.
	    '`l`.`note`, '.
	    '`r`.`zone`, '.
			'`r`.`raidID`, '.
			'`p`.`guild_name`, '.
			'`c`.`member_id`, '.
			'`g`.`guild_id`, ';
	
	$mainTables =
	    'FROM `'.$roster->db->table('items','raidtracker').'` AS l'.
			' LEFT JOIN `'.$roster->db->table('raids','raidtracker').'` AS r ON `r`.`raidID` = `l`.`raidFK`'.
			' LEFT JOIN `'.$roster->db->table('raidmembers','raidtracker').'` AS p ON `p`.`name` = `l`.`member`'.
			' LEFT JOIN `'.$roster->db->table('guild').'` AS g ON `p`.`guild_name` = `g`.`guild_name`'.
			' LEFT JOIN `'.$roster->db->table('players').'` AS c ON `c`.`name` = `l`.`member`'.
			' WHERE r.realm = "'.$roster->data['server'].'" AND l.deleted = 0'.
			$qualitystr .
			' AND l.loottime > "'.$startdate.'" AND l.loottime < "'.$enddate.'"'.
//			' GROUP BY `l`.`loottime` '.
	    ' ORDER BY ';
	
	$always_sort = ' `l`.`loottime` DESC, `l`.`member` ASC, `l`.`itemname` ASC' ;
	
	/*
	$FIELD['lootID'] = array (
		'lang_field' => 'lootID',
		'order'    => array( '`l`.`lootID` ASC' ),
		'order_d'    => array( '`l`.`lootID` DESC' ),
	//	'value' => array($memberlist,'icon_value'),
		'js_type' => 'ts_number',
		'display' => 3,
	);
	*/
	
	$FIELD['icon'] = array (
//		'lang_field' => 'Detail',
		'lang_field' => $roster->locale->act['item'],
		'order'    => array( '`l`.`icon` ASC' ),
		'order_d'    => array( '`l`.`icon` DESC' ),
		'value' => 'icon_value',
		'js_type' => 'ts_string',
		'display' => 3,
	);
	
	$FIELD['itemname'] = array (
		'lang_field' => $roster->locale->act['h_item_name'],
		'order'    => array( '`l`.`itemname` ASC' ),
		'order_d'    => array( '`l`.`itemname` DESC' ),
		'value' => 'itemname_value',
		'js_type' => 'ts_string',
		'display' => 2,
	);
	
	$FIELD['member'] = array (
		'lang_field' => $roster->locale->act['h_who_received'],
		'order'    => array( '`l`.`member` ASC' ),
		'order_d'    => array( '`l`.`member` DESC' ),
		'value' => 'member_value',
		'js_type' => 'ts_string',
		'display' => 3,
	);
	
	$FIELD['guild_name'] = array (
		'lang_field' => 'Guild',
		'order'		=> array( '`p`.`guild_name` ASC' ),
		'order_d'	=> array( '`p`.`guild_name` DESC' ),
		'value' 	=> 'guild_value',
		'js_type'	=> 'ts_string',
		'display'	=> 3,
	);
	
	$FIELD['loottime'] = array (
		'lang_field' => $roster->locale->act['h_date_received'],
		'order' => array( '`l`.`loottime` ASC' ),
		'order_d' => array( '`l`.`loottime` DESC' ),
		'value' => 'loottime_value',
		'js_type' => 'ts_string',
		'display' => 2,
	);
	
	$FIELD['boss'] = array (
		'lang_field' => $roster->locale->act['tooltip_boss'],
		'order' => array( '`l`.`boss` ASC' ),
		'order_d' => array( '`l`.`boss` DESC' ),
		'value' => 'boss_value',
		'js_type' => 'ts_string',
		'display' => 2,
	);
	
	$FIELD['zone'] = array (
		'lang_field' => $roster->locale->act['zone'],
		'order' => array( '`r`.`zone` ASC' ),
		'order_d' => array( '`r`.`zone` DESC' ),
		'value' => 'zone_value',
		'js_type' => 'ts_string',
		'display' => 2,
	);
	
	// Combine the main query. The '1' is to fix the trailing comma for the fields list.
	$mainQuery = $mainSelect . '1 ' . $mainTables;
	
	$memberlist->prepareData($mainQuery, $always_sort, $FIELD, 'lootlist');
	
	echo $memberlist->makeFilterBox();
	
	echo $memberlist->makeToolBar('horizontal');
	
	echo "<br />\n".border('sgreen','start')."\n";
	echo "<br />\n<strong>".$roster->locale->act['raidtracker_info']." ".$roster->locale->act['realm_loot']." for<br> ".$roster->data['server']."</strong>\n<hr />";
	echo $tracker->CreateLootSelectBox('qSelect',$quality,date("Y-m-d",strtotime($startdate)),date("Y-m-d",strtotime($enddate)));
	echo border('sgreen','end');
	
	echo "<br />\n".border('syellow','start')."\n";
	echo $memberlist->makeMembersList();
	echo border('syellow','end');
	
	aprint($mainQuery.$always_sort);

}

/**
 * Controls Output of the Icon Column
 *
 * @param array $row - of character data
 * @return string - Formatted output
 */
function icon_value ( $row, $field ) {
	global $roster, $itracker;
	
	if( !empty($row[$field]) ) {
		$icon = $itracker->fetchItemOrArmory($row['itemref'], $row['itemname']);
		
		return $icon;
	} else return '<div style="display:none; ">Nada</div>';
}
/**
 * Controls Output of the Zone Column
 *
 * @param array $row - of character data
 * @return string - Formatted output
 */
function zone_value ( $row, $field )
{
	global $roster, $tracker;

	if( !empty($row[$field]) )
	{
		$icon = htmlspecialchars(nl2br($row[$field]));

		$icon = '<img src="'.$tracker->GetRaidIcon($row['zone']).'" style="cursor:help;" '.makeOverlib($icon,$roster->locale->act['zone'],'',1,'',',WRAP').' alt="[]" />';
	}
	else
	{
		$icon = '&nbsp;';
	}

	return '<div style="display:none; ">'.htmlentities($row[$field]).'</div>'.$icon;
}

/**
 * Controls Output of the Item Name Column
 *
 * @param array $row
 * @return string - Formatted output
 */
function itemname_value ( $row, $field )
{
	global $roster;

	if( $row['itemref'] ) {
		return '<div style="display:none; cursor:help;" ><font color="#'.substr($row['color'],2).'">'. $row['itemname'] . 
				'</font></div><a href="'.makelink("realm-raidtracker-loot&amp;itemref=".$row['itemref']).'" '.
				makeOverlib($roster->locale->act['who_received'],$roster->locale->act['h_who_received'],'',1,'',',WRAP').
				'><font color="#'.substr($row['color'],2).'">' . $row['itemname'] . '</font></a>';
	} else {
		return '<div style="display:none; "><font color="#'.substr($row['color'],2).'">'. $row['itemname'] . '</font></div><font color="#'.substr($row['color'],2).'">' . $row['itemname'] . '</font>';
	}
}

/**
 * Controls Output of the Member Column
 *
 * @param array $row
 * @return string - Formatted output
 */
function member_value ( $row, $field )
{
	global $roster;

	if( $row['member_id'] )
	{
		return '<div style="display:none; ">' . $row['member'] . '</div><a href="' .
				makelink('char-raidtracker-loot&amp;a=c:' . $row['member_id']) . '" '.
				makeOverlib($roster->locale->act['view_char_loot'],$roster->locale->act['char_loot'],'',1,'',',WRAP').
				'>' . $row['member'] . '</a></div>';
	}
	else
	{
		return '<div style="display:none; ">' . $row['member'] . '</div>' . $row['member'];
	}
}

/**
 * Controls Output of the loottime Column
 *
 * @param array $row - of character data
 * @return string - Formatted output
 */
function loottime_value ( $row, $field )
{
	global $roster,$addon;

	if( !empty($row['raidID']) )
	{
//		$time = readbleDate(htmlspecialchars(nl2br($row[$field])));
//		$time = strftime($addon['config']['raidtracker_datedisplay'], strtotime(nl2br($row[$field])));
		$time = date($addon['config']['raidtracker_datedisplay'], strtotime($row[$field]));
		return '<div style="display:none; ">' . $time . '</div><a href="' .
						makelink('realm-raidtracker&amp;raidID=' . $row['raidID']) . '" '.
						makeOverlib($roster->locale->act['view_raid'],$roster->locale->act['h_view_raid'],'',1,'',',WRAP').
						'>' . $time . '</a></div>';
	}
	else
	{
		return '<div style="display:none; ">' . $row[$field] . '</div>' . $row[$field];
	}
}

/**
 * Controls Output of the boss Column
 *
 * @param array $row - of character data
 * @return string - Formatted output
 */
function boss_value ( $row, $field )
{
	global $roster, $tracker;

	if( !empty($row[$field]) )
	{
		$icon = htmlspecialchars(nl2br($row[$field]));

		$icon = '<img src="'.$tracker->GetBossIcon($row['boss']).'" style="cursor:help;" '.makeOverlib($icon,$roster->locale->act['boss'],'',1,'',',WRAP').' alt="[]" />';
	}
	else
	{
		$icon = '&nbsp;';
	}

	return '<div style="display:none; ">'.htmlentities($row[$field]).'</div>'.$icon;
}

/**
 * Controls Output of the Guild Name Column
 *
 * @param array $row
 * @return string - Formatted output
 */
function guild_value ( $row, $field )
{
	global $roster;

	if( $row['guild_id'] )
	{
		return '<div style="display:none; ">' . $row['guild_name'] . '</div><a href="' . makelink('guild-memberslist&amp;a=g:' . $row['guild_id']) . '">' . $row['guild_name'] . '</a></div>';
	}
	else
	{
		return '<div style="display:none; ">' . $row['guild_name'] . '</div>' . $row['guild_name'];
	}
}
