<?php
 
class raidtracker_search
{
	var $options;
	var $result = array();
	var $result_count = 0;
	var $link_next;
	var $link_prev;
	var $data = array();	// Addon data
 
 
	function search( $search , $url_search , $limit=10 , $page=0 )
	{
		global $roster;
 
		$first = $page*$limit;
 
		$q = "SELECT `raids`.`raidnum`, `raids`.`raidid`, `raids`.`instanceid`, "
			. "`raids`.`end`, `raids`.`zone`, `raids`.`note`, `raids`.`deleted`, "
			. "DATE_FORMAT( DATE_ADD(`raids`.`raidid`, INTERVAL "
			. $roster->config['localtimeoffset'] . " HOUR ), '" . $roster->locale->act['raidtracker_datedisplay'] . "' ) as date_format, "
			. "COUNT(`raids`.`raidid`) AS raid_count "
			. "FROM `". $roster->db->table('raids','raidtracker') ."` raids "
			. "WHERE (`raids`.`zone` LIKE '%$search%' "
			. "OR `raids`.`note` LIKE '%$search%' "
			. "OR `raids`.`raidid` LIKE '%$search%' "
			. "OR `raids`.`raidnum` LIKE '%$search%') "
			. "AND `raids`.`deleted` IS NULL "
			. "GROUP BY `raids`.`raidid` "
			. "LIMIT $first," . ($limit+1) .";";
 
		$result = $roster->db->query($q);
		$nrows = $roster->db->num_rows($result);
 
		$x = ($limit > $nrows) ? $nrows : $limit;
		if( $nrows > 0 )
		{
			while( $x > 0 )
			{
				list($raidnum, $raidid, $instanceid, $end, $zone, $note, $deleted) = $roster->db->fetch($result);
 
				$item['raidid'] = $raidid;
				$item['zone'] = $zone;
				$item['note'] = $note;
				$item['url'] = makelink('guilds-raidtracker&amp;id=' . $raidnum);
 
				if( $html == '1' && $this->data['config']['raid_html'] >= 0 )
				{
					$content = $content;
				}
				else
				{
					$content = htmlentities($content);
				}
				$content = nl2br($content);
 
				$array = explode(' ',$content,101);
				if( isset($array[100]) )
				{
					unset($array[100]);
					$item['more_text'] = true;
				}
				else
				{
					$item['more_text'] = false;
				}
				$item['short_text'] = implode(' ',$array);
 
				$item['footer'] = ($comments == 0?'No':$comments) . ' comment' . ($comments == 1?'':'s');
 
				$this->add_result($item);
				unset($item);
				$x--;
			}
		}
 
		if( $page > 0 )
		{
			$this->link_prev = '<a href="' . makelink('search&amp;page=' . ($page-1) . '&amp;search=' . $url_search . '&amp;s_addon=' 
. $this->data['basename']) . '"><strong>' . $roster->locale->act['search_previous_matches'] . $this->data['basename'] . '</strong></a>';
		}
		if( $nrows > $limit )
		{
			$this->link_next = '<a href="' . makelink('search&amp;page=' . ($page+1) . '&amp;search=' . $url_search . '&amp;s_addon=' 
. $this->data['basename']) . '"><strong> ' . $roster->locale->act['search_next_matches'] . $this->data['basename'] . '</strong></a>';
		}
	}
 
	function add_result( $resultarray )
	{
		$this->result[$this->result_count++] = $resultarray;
	}
}
