<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * enUS Locale
 *
 * @copyright  2002-2007 WoWRoster.net
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: enUS.php 1488 2007-11-29 04:16:07Z Gaxme $
 * @link       http://www.wowroster.net
 * @package    RaidTracker
 * @subpackage Locale
*/

// Info and description
$lang['raidtracker_info'] = 'RaidTracker';
$lang['raidtracker_desc'] = 'Displays info about raids and loot uploaded to Roster';

/**
 * Administrative wordings
 */
// Menu buttons
$lang['admin']['raidtracker_conf'] = 'General|General Configuration Options';
$lang['admin']['raidtracker_items'] = 'Item Options|For storage of raid loot';
$lang['admin']['raidtracker_raids'] = 'Raid Options|For storage of raids and zones';
$lang['admin']['raidtracker_attend'] = 'Attendance Options|For player attendance';
$lang['admin']['raidtracker_bosses'] = 'Boss Options|For boss kill options';
$lang['admin']['raidtracker_debug'] = 'Debug|Debugging options';
$lang['manage_raids'] = 'Manage Raids|Manage stored raids';
$lang['manage_loot'] = 'Manage Loot|Manage stored loot';
$lang['manage_bosses'] = 'Manage Bosses|Manage stored bosses';

// Configuration menu
$lang['admin']['raidtracker_minver'] = 'Min CTRT Version|Minimum version of the MLdkp modified CT_Raidtracker';
$lang['admin']['raidtracker_enable'] = 'Global Enable|Globally enables or disables the raidtracker<br>Default: Enabled';
$lang['admin']['raidtracker_adminaccess'] = 'Admin Level|Minimum access level to administrate the data';
$lang['admin']['raidtracker_uploadaccess'] = 'Upload Level|Access level required to upload data';
$lang['admin']['raidtracker_viewaccess'] = 'View Level|Minimum access level to view data';
$lang['admin']['raidtracker_tooltips'] = 'Use Tooltips|Allow raidtracker to download item tooltips from the Armory';
$lang['admin']['raidtracker_datedisplay'] = 'Date Format|How dates are displayed. For more information, see http://www.php.net/date';
$lang['admin']['raidtracker_querydefault'] = 'Timespan Default|How far back to default for list queries (raids, bosses, loot) in seconds.<br>Example: 31536000 = 365 days.<br>Default: 7776000 = 90 days.';
$lang['admin']['raidtracker_imgformat'] = 'Image Format|Your image format for icon images';
$lang['admin']['raidtracker_imageloc'] = 'Image Location|Image storage location. Default: images';
$lang['admin']['raidtracker_transdb'] = 'Transaction DB Enable|Enable database transactional processing. If you do not know what this is, leave it set to No';
$lang['admin']['raidtracker_default_guild'] = 'Default Guild|Select the default guild to upload data for.<br>This is used when no guild, realm, and character information can<br>be obtained.';

// Item menu
$lang['admin']['raidtracker_storeitems'] = 'Store Items|Global: Store items in the database on upload';
$lang['admin']['raidtracker_minitemlvl'] = 'Minimum Rarity|The minimum rarity of items to store in the database';
$lang['admin']['raidtracker_itemcache_expires'] = 'Cache Expiration|The number of days before an item in the cache expires<br>and is retrieved from the armory.';
$lang['admin']['raidtracker_storeplayers'] = 'Store Players|Whether to record players present at the time an object is looted.<br>Note: This requires it to be enabled in the WoW Addon, and is <strong>extremely</strong><br>memory intensive.';
$lang['admin']['raidtracker_itemscombined'] = 'Combine Loot|If on, this displays looters with the item looted';

// Raid menu
$lang['admin']['raidtracker_storeraids'] = 'Store Raids|Global: Store raids in the database on upload';
$lang['admin']['raidtracker_expandraids'] = 'Expand Raids|Whether raid displays start expanded or collapsed';
$lang['admin']['raidtracker_timediff'] = 'Time Difference|The number of hours used to compare raids without IDs to one another.<br>Larger numbers will result in more matches, and less raid collation.';
$lang['admin']['raidtracker_storeunknown'] = 'Store Unknown|If this is set to off, any raid where the zone cannot be determined will be ignored';
$lang['admin']['raidtracker_mergeraids'] = 'Merge Raids|Whether RaidTracker attempts to combine raids with the same instance ID.<br>Set to No to always create a new raid.';
$lang['admin']['raidtracker_mergelimit'] = 'Merge Raid Limit|If merging is enabled, this sets an upper limit on the amount<br>of time between raids <strong>even of the same instance ID</strong>.<br>The default, 0, means it will always merge raids.<br>Example: Setting this to 24 means that even a raid sharing an<br>instance ID that happens 1 day or more later will be treated as a new raid.<br>';
$lang['admin']['raidtracker_storeoldworld'] = 'Store Pre-BC|Whether pre-BC raids are stored in the database';
$lang['admin']['raidtracker_storebc'] = 'Store BC|Whether BC raids are stored in the database';
$lang['admin']['raidtracker_storewlk'] = 'Store WLK|Whether WLK raids are stored in the database';
$lang['admin']['raidtracker_storepvp'] = 'Store PvP|Whether PvP battlegrounds are stored in the database.<br>Note: These often show up as "unknown" and are not detected.';
		
// Attendance menu
$lang['admin']['raidtracker_storeattend'] = 'Store Attendance|Global: Store raid attendance on upload.<br>Note: Also effects players stored on item upload.';
$lang['admin']['raidtracker_playerleave'] = 'Leaves|Whether player leaves are stored in the database.<br>If this is off, time raiding will not be calculated.';
$lang['admin']['raidtracker_playerlink'] = 'Active Link|Choose internal to link to your roster, Armory to link to the WoW Armory';
$lang['admin']['raidtracker_armorytag'] = 'Armory Tag|The argument used to grab character info<br>from the armory. Included in case it changes.<br>Default: character-sheet.xml?r={realm}&n={charname}<br>See release notes for additional info.';

// Boss menu
$lang['admin']['raidtracker_storebosses'] = 'Store Bosses|Global: Store boss kills in the database';
$lang['admin']['raidtracker_storebossattend'] = 'Store Attendance|Store attendance on boss kills.<br>Note: Requires activation in the raidtracker addon.';
$lang['admin']['raidtracker_oldbosses'] = 'Oldworld Bosses|Global: Store/Display Old-World Bosses';
$lang['admin']['raidtracker_bcbosses'] = 'BC Bosses|Global: Store/Display BC Bosses';
$lang['admin']['raidtracker_wlkbosses'] = 'WLK Bosses|Global: Store/Display WLK Bosses';

// Debug menu
$lang['admin']['raidtracker_debug'] = 'Debug|Global: Enable verbose debugging';

/**
 * General use wordings
 */
$lang['admin']['raidtracker_loot'] = 'Loot';

// Display wordings
$lang['loothistory'] = 'Loot History';
$lang['bossprogress'] = 'Boss Progress';
$lang['bossprogressbc'] = 'Boss Progress (BC)';
$lang['bossprogresswlk'] = 'Boss Progress (WLK)';
$lang['summary'] = 'Summary';
$lang['raid_admin'] = 'Raid Admin';
$lang['randomraid'] = 'Random Raid Event';
$lang['loottype'] = 'Loot Type';
$lang['allzones'] = 'All Zones';
$lang['alltypes'] = 'All Types';
$lang['min_loot_quality'] = 'Minimum Quality';
$lang['h_select_options'] = 'Select Search Options';
$lang['select_dates'] = 'Select the search date';
$lang['h_select_dates'] = '(Click the date headers to open a calendar)';
$lang['start_date'] = 'Start Date';
$lang['end_date'] = 'End Date';

// Raidlist
$lang['lootcount'] = '# Loot';
$lang['bosscount'] = '# Bosses';
$lang['attendees'] = '# Attendees';
$lang['h_select_zone'] = 'Select a Zone';
$lang['select_raid'] = 'Select a raid:';
$lang['looters'] = 'Looters';
$lang['looted_by'] = 'Looted by:';
$lang['joined_raid'] = 'Joined Raid';
$lang['left_raid'] = 'Left Raid';
$lang['spent_time'] = 'Spent %t %d in raid';
$lang['bosses_killed'] = 'Bosses Killed';
$lang['boss'] = 'Boss';
$lang['raidid'] = 'RaidID';
$lang['instanceid'] = 'InstanceID';
$lang['raidtime'] = 'Raid Time';
$lang['wipes'] = 'Wipes';
$lang['bosses'] = 'Bosses';
$lang['guild_raids'] = 'Guild Raids';
$lang['realm_raids'] = 'Realm Raids';
$lang['char_raids'] = 'Character Raids';

// Loot modules
$lang['guild_loot'] = 'Guild Loot';
$lang['realm_loot'] = 'Realm Loot';
$lang['char_loot'] = 'Character Loot';
$lang['h_who_received'] = 'Who Received';
$lang['who_received'] = 'Click to see who has received this item';
$lang['guild_members'] = 'View Members of this Guild';
$lang['view_char_loot'] = "View this character's loot";
$lang['view_raid'] = "View this raid's details";
$lang['h_view_raid'] = "Raid Details";
$lang['h_item_name'] = "Item Name";
$lang['h_date_received'] = "Date Received";

// Messages, error and otherwise
// Variables replaced in certain functions:
//    %n = current number
//    %t = total number
//    %r = raidid
//    %k = raid key
//    %z = zone
//    %g = guild
//    %s = server
//    %f = faction
//    %i = item
//    %p = independent by function (junk)
$lang['rt_critical_error'] = 'Critical Error';
$lang['rt_global_disable'] = 'Raidtracker is globally disabled.';
$lang['rt_no_guildinfo'] = 'Raidtracker could not retrieve any guild information!';
$lang['rt_found_num_raids'] = 'Found %n raids in the data.';
$lang['rt_processing_raid'] = 'Processing raid %r of %n:';
$lang['rt_ignored_byzone'] = 'Raid ignored due to zone restrictions.';
$lang['rt_ignored_old'] = 'Raid ignored due to old-world zone restriction.';
$lang['rt_ignored_bc'] = 'Raid ignored due to Burning Crusade zone restriction.';
$lang['rt_ignored_wlk'] = 'Raid ignored due to Wrath of the Lich King zone restriction.';
$lang['rt_ignored_pvp'] = 'Raid ignored due to PvP zone restriction.';
$lang['rt_seek_byraidid'] = 'Seeking existing raid with raidid: %r, Key: %k, Zone: %z, Guild: %g, Server: %s';
$lang['rt_fail_byraidid'] = 'Failed to find existing raidid %r.';
$lang['rt_seek_bytime'] = 'Seeking raid by key and zone within %n hours.';
$lang['rt_seek_fail'] = 'Failed to find an existing raid match.';
$lang['rt_seek_successbykey'] = 'Found %n possible match(es) for raidid %r by key and zone search.';
$lang['rt_seek_successbyid'] = 'Found existing raidid %r by raidid search. (Raidnum: %n)';
$lang['rt_seek_idfail_mergelimit'] = 'Found existing raid for ID %r, but additional data past merge limit. Creating a new raid.';
$lang['rt_seek_multi'] = 'More than one possible match found. Inserting a new raid.';
$lang['rt_success_newraid'] = 'Successfully inserted new raid and received ID %n';
$lang['rt_fail_newraid'] = $lang['rt_critical_error'].": Could not enter a new raid!";
$lang['rt_raid_processed'] = 'Raid %r successfully processed.';
$lang['rt_nostore_items'] = 'Raidtracker is configured <strong>not</strong> to store items.';
$lang['rt_items_process_new'] = 'Processing items for new raidID %r.';
$lang['rt_items_process_old'] = 'Processing items for existing raidID %r.';
$lang['rt_insert_item_count'] = 'Inserting %n items into raid.';
$lang['rt_insert_players_count'] = 'Adding or updating %n raid members.';
$lang['rt_items_skipped_count'] = 'Item storage skipped due to equal item count.';
$lang['rt_item_rarity_pass'] = 'Storing <font color="%p">%i</font> since it passed rarity restrictions.';
$lang['rt_item_rarity_fail'] = 'Ignoring item <font color="%p">%i</font> since it failed rarity restrictions.';
$lang['rt_item_exists'] = 'Ignoring item <font color="%p">%i</font> because it already exists.';
$lang['rt_item_attend_attempt'] = 'Attempting to store attendees for loot %n from raid %r.';
$lang['rt_item_attend_nodata'] = 'No attendee data found for loot %i from raid %r.';
$lang['rt_item_attend_store'] = 'Storing %n attendees for loot %i from raid %r.';
$lang['rt_no_items'] = 'No item data found for raidID %r.';
$lang['rt_db_fail_itemattend'] = 'Failed to retrieve data from the item attendance table!';
$lang['rt_item_insert_fail'] = 'Failed to insert item into raidtracker!';
$lang['rt_rarity_error'] = 'Error in rarity check: <font color="%i">%p</font> did not match any existing rarity!';
$lang['rt_attend_disabled'] = 'Attendance tracking is globally disabled.';
$lang['rt_leave_disabled'] = 'Attendance tracking for player leaves is disabled.';
$lang['rt_db_fail_leaves'] = 'Failed to retrive data from the leaves table!';
$lang['rt_db_fail_joins'] = 'Failed to retrieve data from the joins table!';
$lang['rt_leaves_insert'] = 'Inserting %n player leaves into the database.';
$lang['rt_joins_insert'] = 'Inserting %n player joins into the database.';
$lang['rt_storeplayers_disabled'] = 'Loot attendees storage disabled.';

// Boss parse messages
$lang['rt_bosses_disabled'] = 'Boss tracking disabled.';
$lang['rt_db_fail_bosses'] = 'Failed to retrieve data from the boss table!';
$lang['rt_db_fail_bossattend'] = 'Failed to retrieve data from the boss attendance table!';
$lang['rt_bossattend_off'] = 'Bosses: Configured not to store attendance data.';
$lang['rt_bosses_insert'] = 'Inserting %n bosses into the database for raid %r.';
$lang['rt_bossattend_insert'] = 'Inserting %n players for boss %p.';

// Raidview colorings
// Format: array( [index] => array( 'color' => 'hexstring', 'desc' => 'title' ))
// Colors should be arranged from 0 up, with zero being the lowest quality
$lang['lootTypes'] = array(
	0 => array( 'color' => 'ff9d9d9d', 'desc' => 'Poor' ),
	1 => array( 'color' => 'ffffffff', 'desc' => 'Common' ),
	2 => array( 'color' => 'ff1eff00', 'desc' => 'Uncommon' ),
	3 => array( 'color' => 'ff0070dd', 'desc' => 'Rare' ),
	4 => array( 'color' => 'ffa335ee', 'desc' => 'Epic' ),
	5 => array( 'color' => 'ffff8000', 'desc' => 'Legendary' ),
	6 => array( 'color' => 'ffe6cc80', 'desc' => 'Artifact' ),
);

// Button text
$lang['bosstrackerbutton'] = 'Boss Tracker|Track bosskills from uploaded data';
$lang['attendancetrackerbutton'] = 'Raid Attendance|Track raid attendance';
$lang['raidtrackerbutton'] = 'Raids|Show raid tracking data';
$lang['loottrackerbutton'] = 'Loot|Show raid loot';
$lang['charloot'] = 'Character Loot|Items this character has received from raids';
$lang['char_raids'] = 'Character Raids|View raids this character has attended.';
$lang['realmloot'] = 'Realm Loot|View raid loot drops for all guilds on this server';
$lang['guildloot'] = 'Guild Loot|Show all the item drops for this guild';
$lang['char_bosses'] = 'Character Bosses|Show boss kills this character has participated in';
$lang['guild_bosses'] = 'Guild Bosses|Show boss kills this guild has participated in';
$lang['realm_bosses'] = 'Realm Bosses|Show all bosses killed by guilds on this realm';

// Wordings for template engine
$lang['admin']['delete_raid'] = 'Delete Raid|Mark a raid as deleted';
$lang['admin']['add_raidmember'] = 'Add Raid Member|Add a member to a raid';
$lang['admin']['delete_raidmember'] = 'Delete Raid Member|Remove a member from a raid';
$lang['admin']['add_raidloot'] = 'Add Raid Loot|Add a loot ID to a raid';
$lang['admin']['delete_raidloot'] = 'Delete Raid Loot|Remove loot from a raid';
$lang['admin']['assign_raidloot'] = '(Re)Assign Loot|(Re)Assign Loot to a member';

// Zone definitions
// Warning: Zone names must be EXACTLY as they appear in the CT_Raidtracker.lua
// Format:
//   ZoneName => array( "icon" => "name", "nickname" => "nick", "pack" => "xpac" ),
$lang['raidtracker_zones'] = array(
        "Random Raid" => array( "icon" => "random", "nickname" => "Random", "pack" => "all" ),
        "World Bosses" => array( "icon" => "outdoor", "nickname" => "World", "pack" => "all" ),
				"Unknown" => array( "icon" => "unknown", "nickname" => "Unknown", "pack" => "all" ),
        "Zul'Gurub" => array( "icon" => "zg", "nickname" => "ZG", "pack" => "old" ),
        "Onyxia's Lair" => array( "icon" => "onx", "nickname" => "Ony", "pack" => "old" ),
        "Molten Core" => array( "icon" => "mc", "nickname" => "MC", "pack" => "old" ),
        "Blackwing Lair" => array( "icon" => "bwl", "nickname" => "BWL", "pack" => "old" ),
        "Ahn'Qiraj Ruins" => array( "icon" => "aq20", "nickname" => "AQ20", "pack" => "old" ),
        "Ahn'Qiraj Temple" => array( "icon" => "aq40", "nickname" => "AQ40", "pack" => "old" ),
        "Naxxramas" => array( "icon" => "nax", "nickname" => "Nax", "pack" => "old" ),
        "Karazhan" => array( "icon" => "kz", "nickname" => "KZ", "pack" => "bc" ),
        "Gruul's Lair" => array( "icon" => "gl", "nickname" => "Gruul", "pack" => "bc" ),
        "Magtheridon's Lair" => array( "icon" => "mag", "nickname" => "Mag", "pack" => "bc" ),
        "Serpentshrine Cavern" => array( "icon" => "sc", "nickname" => "SSC", "pack" => "bc" ),
        "Tempest Keep: The Eye" => array( "icon" => "tk", "nickname" => "Eye", "pack" => "bc" ),
        "Black Temple" => array( "icon" => "bt", "nickname" => "BT", "pack" => "bc" ),
        "Battle of Mount Hyjal" => array( "icon" => "cot", "nickname" => "Hyjal", "pack" => "bc" ),
        "Zul'Aman" => array( "icon" => "za", "nickname" => "ZA", "pack" => "bc" ),
        "Sunwell Plateau" => array( "icon" => "swp", "nickname" => "SWP", "pack" => "bc" ),
        "Icecrown Citadel" => array( "icon" => "icc", "nickname" => "ICC", "pack" => "wlk"  ),
				"Arathi Basin" => array( "icon" => "ab", "nickname" => "ab", "pack" => "pvp" ),
				"Alterac Valley" => array( "icon" => "av", "nickname" => "av", "pack" => "pvp" ),
				"Warsong Gulch" => array( "icon" => "wsg", "nickname" => "wsg", "pack" => "pvp" ),
				"Eye of the Storm" => array( "icon" => "eots", "nickname" => "eots", "pack" => "pvp" ),
);
?>
