<?php

if (!defined('ROSTER_INSTALLED') ) {
        exit('Detected invalid access to this file!');
}

$roster_login = new RosterLogin();

if( !$roster_login->getAuthorized($addon['config']['raidtracker_adminaccess']))
{
        print $roster_login->getMessage().
        $roster_login->getLoginForm($addon['config']['raidtracker_adminaccess']);

        return; //To the addon framework
}

echo "Manage bosses<br>";

global $roster;

$locale = isset($_GET['locale']) ? htmlspecialchars($_GET['locale']) : 'enUS';

include_once( '/home/publicface/www/vestra/outside/roster172b/addons/RaidTracker/'.$locale.'.php' );
$q = "SELECT zone_id,zone_name FROM `".$roster->db->table('zonelist','raidtracker')."`;";
$ret = $roster->db->query($q);
$zones = $roster->db->fetch_all($ret);
$bosses = $rt_wordings[$locale]['Bosses'];
$tzones = array_merge( $rt_wordings[$locale]['Zones'], $rt_wordings[$locale]['ZonesBC'] );

echo "<strong>$locale strings:</strong><br>";
foreach(array_keys($zones) as $zid) {
	$zname = $zones[$zid]['zone_name'];
	$zlocal = $tzones[$zname];
	$bosslist = $bosses[$zname];
	$zoneid = $zones[$zid]['zone_id'];
	echo "<br>Zone: $zname => $zlocal</strong><br>";
	$q2 = "SELECT boss_id,boss_name FROM `".$roster->db->table('bosslist', 'raidtracker')."` WHERE boss_zone = \"$zname\";";
	$ret2 = $roster->db->query($q2);
	$blist = $roster->db->fetch_all($ret2);
	if(isset($_GET['sql'])) {
		foreach(array_keys($bosslist) AS $bname) {
        	$blocal = $bosslist[$bname];
        	$msg = "INSERT INTO `roster20_addons_raidtracker_bosslist`".
					" VALUES (NULL, \"$bname\", \"$zname\", $zoneid, \"$locale\", \"$blocal\");";
        	echo $msg."<br>";
		}
	} else {
		foreach(array_keys($blist) AS $bid) {
			$bname = $blist[$bid]['boss_name'];
			$blocal = $bosslist[$bname];
			if(!isset($_GET['template']))
			$msg2 = "Boss: $bname => $blocal";
			else $msg2 = "Boss: $bname => ";
			echo $msg2."<br>";
		}
	}
}

?>
